unit fmMTMessage;
//==============================================================================
//  
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ImgList, ComCtrls, Mask;

type
  TfrmMTMes = class(TForm)
    paInfo: TPanel;
    buHide: TButton;
    buClear: TButton;
    meText: TMemo;
    pcMain: TPageControl;
    tsLog: TTabSheet;
    tsHistory: TTabSheet;
    meLog: TMemo;
    lvHistory: TListView;
    ilHistory: TImageList;
    procedure buClearClick(Sender: TObject);
    procedure buHideClick(Sender: TObject);
    procedure lvHistoryCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
  private
    FLastM: string;
    function GetNextWord(var s: string): string;
    procedure UpdateTotalRow();
  public
    FProfit: double;
    procedure AddMessage(aMess: string; aShow: boolean);
    procedure AddHistory(aMess: string);
  end;

var
  frmMTMes: TfrmMTMes;
           
implementation

{$R *.dfm}

{ TfrmMTMes }

procedure TfrmMTMes.AddHistory(aMess: string);
//==============================================================================
//      
//
// :  .                                                07.04.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  lItem: TListItem;
  s: TStringList;
  lMess: string;
  v: double;
  v1: double;
  FFormatSettings: TFormatSettings;
begin
  FFormatSettings.DecimalSeparator := '.';

  if aMess = 'clear' then
    lvHistory.Items.Clear else
  begin
    s := TStringList.Create;
    try
      lMess := aMess;
      s.Add(GetNextWord(lMess)); // 0 - OrderLots
      s.Add(GetNextWord(lMess)); // 1 - OrderMagicNumber
      s.Add(GetNextWord(lMess)); // 2 - OrderTicket
      s.Add(GetNextWord(lMess)); // 3 - OrderSymbol
      s.Add(GetNextWord(lMess)); // 4 - OrderClosePrice
      s.Add(GetNextWord(lMess)); // 5 - OrderCloseTime
      s.Add(GetNextWord(lMess)); // 6 - OrderOpenPrice
      s.Add(GetNextWord(lMess)); // 7 - OrderOpenTime
      s.Add(GetNextWord(lMess)); // 8 - OrderSwap
      s.Add(GetNextWord(lMess)); // 9 - OrderProfit
      s.Add(GetNextWord(lMess)); // 10 - Ordertype

      lItem := lvHistory.Items.Add;
      lItem.Caption := s[2];
      if s[10] = 'BUY' then
        lItem.StateIndex := 1 else
      if s[10] = 'SELL' then
        lItem.StateIndex := 0;

      lItem.SubItems.Add(s[10]); // type
      lItem.SubItems.Add(s[7]); // open time
      lItem.SubItems.Add(s[6]); // open price
      lItem.SubItems.Add(s[0]); // value
      lItem.SubItems.Add(s[3]); // Symbol
      lItem.SubItems.Add(s[5]); // close time
      lItem.SubItems.Add(s[4]); // close price
      lItem.SubItems.Add(s[8]); // swap
      lItem.SubItems.Add(s[9]); // profit

      if TryStrToFloat(StringReplace(lItem.SubItems[8], ',', '.', [rfReplaceAll, rfIgnoreCase]), v, FFormatSettings) and
         TryStrToFloat(StringReplace(lItem.SubItems[3], ',', '.', [rfReplaceAll, rfIgnoreCase]), v1, FFormatSettings) then
           if v1 > 0 then
             lItem.SubItems.Add(Format('%g',[v/v1], FFormatSettings)) else
             lItem.SubItems.Add('');

    finally
      s.Free;
    end;
  end;

  UpdateTotalRow();
end;

procedure TfrmMTMes.AddMessage(aMess: string; aShow: boolean);
//==============================================================================
//     
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  if aMess = '' then
    Visible := not Visible else
  if (aMess <> '')and (aMess <> FLastM) then
  begin
    if aShow and (not Visible) then
      Show;

    FLastM := aMess;
    meText.Lines.Text := stringreplace(aMess, '%%%', #13#10, [rfReplaceAll, rfIgnoreCase]);
    meLog.Lines.Add(stringreplace(aMess, '%%%', #13#10, [rfReplaceAll, rfIgnoreCase]));    
  end;
end;

procedure TfrmMTMes.buClearClick(Sender: TObject);
//==============================================================================
//   
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  meText.Lines.Clear;
  meLog.Lines.Clear;
end;

procedure TfrmMTMes.buHideClick(Sender: TObject);
//==============================================================================
//   
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  Close;
end;

function TfrmMTMes.GetNextWord(var s: string): string;
//==============================================================================
//     
//
// :  .                                                07.04.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  i: integer;
  j: integer;
begin
  Result := '';
  i := pos('[',s);
  j := pos(']',s);

  if (i > 0) and (j > i) then
  begin
    Result := copy(s, i+1, j-i-1);
    s := copy(s, j+1, length(s)-j);
  end else
    s := '';
end;

procedure TfrmMTMes.UpdateTotalRow;
var
  i: integer;
  lItem: TListItem;
  lSwap: double;
  lProfit: double;
  lPips: double;

  lSwapAdd: double;
  lProfitAdd: double;
  lPipsAdd: double;
  FFormatSettings: TFormatSettings;
begin
  FFormatSettings.DecimalSeparator := '.';
  lSwap := 0;
  lProfit := 0;
  lPips := 0;

  FProfit := 0;

  if lvHistory.Items.Count > 0 then
    for i := lvHistory.Items.Count - 1 downto 0 do
    begin
      lItem := lvHistory.Items[i];
      if lItem.Caption = 'Total' then
        lItem.Delete else
//        lvHistory.Items.Delete(i) else
      begin
        if TryStrToFloat(StringReplace(lItem.SubItems[7], ',', '.', [rfReplaceAll, rfIgnoreCase]), lSwapAdd, FFormatSettings) then
          lSwap := lSwap + lSwapAdd;

        if TryStrToFloat(StringReplace(lItem.SubItems[8], ',', '.', [rfReplaceAll, rfIgnoreCase]), lProfitAdd, FFormatSettings) then
          lProfit := lProfit + lProfitAdd;

        if TryStrToFloat(StringReplace(lItem.SubItems[9], ',', '.', [rfReplaceAll, rfIgnoreCase]), lPipsAdd, FFormatSettings) then
          lPips := lPips + lPipsAdd;
      end;
    end;


  lItem := lvHistory.Items.Add;
  lItem.Caption := 'Total';
  lItem.StateIndex := 3;


  lItem.SubItems.Add(''); // type
  lItem.SubItems.Add(''); // open time
  lItem.SubItems.Add(''); // open price
  lItem.SubItems.Add(''); // value
  lItem.SubItems.Add(''); // Symbol
  lItem.SubItems.Add(''); // close time
  lItem.SubItems.Add(''); // close price
  lItem.SubItems.Add(FloatToStr(round(lSwap*100)/100, FFormatSettings)); // swap
  lItem.SubItems.Add(FloatToStr(round(lProfit*100)/100, FFormatSettings)); // profit
  lItem.SubItems.Add(FloatToStr(round(lPips*100)/100, FFormatSettings)); // pips



  FProfit := round(lProfit*100)/100 + round(lSwap*100)/100;
end;

procedure TfrmMTMes.lvHistoryCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
var
  lPips: double;
  FFormatSettings: TFormatSettings;
begin
  FFormatSettings.DecimalSeparator := '.';

  DefaultDraw := true;

  if Item.Caption = 'Total' then
    sender.Canvas.Brush.Color := clSilver else

  if TryStrToFloat(StringReplace(Item.SubItems[9], ',', '.', [rfReplaceAll, rfIgnoreCase]), lPips, FFormatSettings) then
  begin
    if lPips > 500 then sender.Canvas.Brush.Color := $0044953E else
    if lPips > 250 then sender.Canvas.Brush.Color := $004FAB47 else
    if lPips > 150 then sender.Canvas.Brush.Color := $005FB957 else
    if lPips > 100 then sender.Canvas.Brush.Color := $007CC776 else
    if lPips > 80 then sender.Canvas.Brush.Color := $009ED69A else
    if lPips > 20 then sender.Canvas.Brush.Color := $00DBF0D9 else
    if lPips > 5 then sender.Canvas.Brush.Color := $00E8F5E7 else
    if lPips < -500 then sender.Canvas.Brush.Color := $003E4495 else
    if lPips < -250 then sender.Canvas.Brush.Color := $00474FAB else
    if lPips < -150 then sender.Canvas.Brush.Color := $00575FB9 else
    if lPips < -100 then sender.Canvas.Brush.Color := $00767CC7 else
    if lPips < -80 then sender.Canvas.Brush.Color := $009A9ED6 else
    if lPips < -20 then sender.Canvas.Brush.Color := $00D9DBF0 else
    if lPips < -5 then sender.Canvas.Brush.Color := $00E7E8F5;
  end;

end;

end.
