unit fmMain;
//==============================================================================
//   
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
interface

uses
  XPMan, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Dialogs, uReader, StdCtrls, ExtCtrls, ShellApi, Menus, Buttons,
  ComCtrls, IniFiles, fmSetting, ImgList;

type
  TfMain = class(TForm)
    tmRefr: TTimer;
    pmTray: TPopupMenu;
    miExit: TMenuItem;
    miShow: TMenuItem;
    miMTHide: TMenuItem;
    miMTShow: TMenuItem;
    paTop: TPanel;
    cbInfo: TComboBox;
    laInfo: TLabel;
    XPManifest1: TXPManifest;
    paButtons: TPanel;
    sbBuy: TSpeedButton;
    sbSell: TSpeedButton;
    sbClose: TSpeedButton;
    sbSettings: TSpeedButton;
    sbQuit: TSpeedButton;
    sbReverse: TSpeedButton;
    sbMinimize: TSpeedButton;
    miSettings: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    sbLog: TSpeedButton;
    laInfo2: TLabel;
    il2: TImageList;
    il3: TImageList;
    procedure tmRefrTimer(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure miShowClick(Sender: TObject);
    procedure miExitClick(Sender: TObject);
    procedure miMTHideClick(Sender: TObject);
    procedure miMTShowClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure sbBuyClick(Sender: TObject);
    procedure sbSellClick(Sender: TObject);
    procedure sbCloseClick(Sender: TObject);
    procedure sbReverseClick(Sender: TObject);
    procedure sbSettingsClick(Sender: TObject);
    procedure sbQuitClick(Sender: TObject);
    procedure sbMinimizeClick(Sender: TObject);
    procedure miSettingsClick(Sender: TObject);
    procedure sbLogClick(Sender: TObject);
  private
    FReader: TReader;
    FKeyList: TList;
    Fhide: boolean;

    FIniFile: TIniFile;
    Fsettings: TSettingRec;
    fSett: TfmSettings;
    FIconLine: integer;
    FIconLine2: integer;
    FIconDigit: integer;
    FIconSign: integer;

    procedure HideApp;
    function CheckOrdersList: boolean;
    function ParseText(TextIn: string; Index: integer): string;
    procedure ShowMTMessage(aMessage: string; aShow: boolean);
  private
    procedure SaveAccountSettings;
    procedure LoadAccountSettings;
    procedure SendAccSett2MT;
    function NormalizeOrder(s: string): string;
  protected
    procedure WM_HotKeyHandler (var Message: TMessage); message WM_HOTKEY;
    Procedure ControlWindow(Var Msg:TMessage); message WM_SYSCOMMAND;
  	Procedure IconMouse(var Msg : TMessage); message WM_USER+1;

    Procedure Icon(n:Integer);
    procedure ProcessOrder(aOrder: string);
  protected
    procedure LoadDefaultSettings;
    procedure UpdateForm;
    procedure SaveSettings;
    procedure showSettings;
    procedure CheckAccount;

    procedure RegHotKeys;
    procedure UnRegHotKeys;
    function RepaintIcon(aValue: double): boolean;
  public
    constructor Create(AOwner: TComponent); override;
    destructor destroy(); override;
  end;

var
  fMain: TfMain;

implementation
uses
  fmOrder, uParseOrder, fmMTMessage;
{$R *.dfm}

{ TfMain }

constructor TfMain.Create(AOwner: TComponent);
//==============================================================================
// 
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  inherited;
  FIconLine := 0;
  FIconLine2 := 0;
  FIconDigit := 0;
  FIconSign := 0;

  frmMTMes := TfrmMTMes.Create(Application);

  FIniFile := TIniFile.Create(Copy(Application.ExeName,1,length(Application.ExeName)-3) + 'ini');
  FReader := TReader.Create;
  FKeyList := TList.Create;
  RegHotKeys;

  LoadDefaultSettings;
  Fhide := false;
end;

destructor TfMain.destroy;
//==============================================================================
// 
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  FReader.Free;

  UnRegHotKeys;
  FKeyList.Free;
  Icon(2); //    

  SaveSettings;
  FIniFile.Free;
  inherited;
end;

procedure TfMain.LoadDefaultSettings;
//==============================================================================
//    ini 
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  Left := FIniFile.ReadInteger('form', 'left', 100);
  Top := FIniFile.ReadInteger('form', 'top', 100);

  Fsettings.FormCaption := FIniFile.ReadString('form', 'caption', '[[ACCOUNT]]: [TOTALCOUNT]/[ORDERCOUNT] [PROFIT]');
  Fsettings.OrderCaption := FIniFile.ReadString('form', 'order', '[OrderIdx].[OrderType]: ([OrderLots]) [OrderProfit2] [OrderSymbol]');
  Fsettings.ShowButtons := FIniFile.ReadInteger('form', 'buttons', 1);
  paButtons.Visible := (Fsettings.ShowButtons = 1);

  Fsettings.ConsoleBlend := FIniFile.ReadInteger('onsole', 'blend', 140);
  Fsettings.ConsoleTop := FIniFile.ReadInteger('onsole', 'top', 1);
  Fsettings.ConsoleRight := FIniFile.ReadInteger('onsole', 'right', 100);

  Fsettings.IconBorder := FIniFile.ReadFloat('form', 'icon', 10);


  Fsettings.IconColorTPLine := FIniFile.ReadInteger('form', 'icon_ColorTPLine', clLime);
  Fsettings.IconColorTPFont := FIniFile.ReadInteger('form', 'icon_ColorTPFont', clLime);

  Fsettings.IconColorSLLine := FIniFile.ReadInteger('form', 'icon_ColorSLLine', $00A851FF);
  Fsettings.IconColorSLFont := FIniFile.ReadInteger('form', 'icon_ColorSLFont', $0082BFFD);
  Fsettings.IconByVirtual := FIniFile.ReadInteger('form', 'icon_virtual', 0);




  frmMTMes.Top := FIniFile.ReadInteger('log', 'top', 100);
  frmMTMes.Left := FIniFile.ReadInteger('log', 'Left', 100);

  Fsettings.AccountNo := '';

  UpdateForm;
end;

procedure TfMain.UpdateForm;
//==============================================================================
//   (  ,  )
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  idx: integer;
  i: integer;
  s: string;
  v: integer;
  v1: double;
  FFormatSettings: TFormatSettings;
begin
  FFormatSettings.DecimalSeparator := '.';
  tmRefr.Enabled := false;
  try
    FReader.Update;
    CheckAccount;

    if Fsettings.IconByVirtual = 0 then
    begin
      if not TryStrToFloat(StringReplace(FReader.Values['[PROFIT]'], ',', '.', [rfReplaceAll, rfIgnoreCase]), v1, FFormatSettings) then
        v1 := 0;

      if RepaintIcon(v1) then
        Icon(3);
    end;

    for i := 0 to FReader.FList2.Count - 1 do
      if length(FReader.FList2[i]) > 0 then
      begin
        s := FReader.FList2[i];
        if s[1] = 'm' then
          ShowMTMessage(copy(s, 2, length(s)), true) else
        if s[1] = 'h' then
          frmMTMes.AddHistory(copy(s, 2, length(s)));
      end;


    FReader.FList2.Clear;

    if Fsettings.accValue > 0 then
    begin
      if Fsettings.accDIR = 'BUY' then
        v := round(StrToFloat(FReader.Values['[DEFCCYBID]']) - Fsettings.accValue) else
        v := round(Fsettings.accValue - StrToFloat(FReader.Values['[DEFCCYASK]']));

      laInfo2.Caption := format('%s: %d',[Fsettings.accDIR, v]);
      laInfo2.Visible := true;
      if Fsettings.IconByVirtual = 1 then if RepaintIcon(v) then Icon(3);
    end else
    begin
      laInfo2.Visible := false;
      if Fsettings.IconByVirtual = 1 then if RepaintIcon(0) then Icon(3);
    end;

    Caption := ParseText(Fsettings.FormCaption, -1);
    laInfo.Caption := format('%s (%s)',[FReader.Values['[DEFCCY]'], FReader.Values['[SPREAD]'] ]);

    if not CheckOrdersList then
    begin
      idx := -1;
      if (cbInfo.ItemIndex > -1) then
      try
        idx := Integer(cbInfo.Items.Objects[cbInfo.ItemIndex]);
      except
        idx := -1;
      end;

      cbInfo.Items.BeginUpdate;
      try
        cbInfo.Items.Clear;
        if FReader.OrderCount > 0 then
        begin
          for i := 0 to FReader.OrderCount - 1 do
          begin
            cbInfo.Items.AddObject(ParseText(Fsettings.OrderCaption, i), TObject(FReader.OrderTicket[i]));
            if idx <> -1 then
              if idx = FReader.OrderProfit[i] then
                cbInfo.ItemIndex := i;
          end;

          if cbInfo.ItemIndex = -1 then
            cbInfo.ItemIndex := FReader.OrderCount - 1;
        end;
      finally
        cbInfo.Items.EndUpdate;
      end;
    end else
    begin

      cbInfo.Items.BeginUpdate;
      try
        idx := cbInfo.ItemIndex;

        if FReader.OrderCount > 0 then
        begin
          for i := 0 to FReader.OrderCount - 1 do
            cbInfo.Items.Strings[i] := ParseText(Fsettings.OrderCaption, i);

         cbInfo.ItemIndex := idx;
        end;
      finally
        cbInfo.Items.EndUpdate;
      end;
    end;

  except
    on e: exception do
    begin
      ShowMessage(E.Message);
      miExitClick(nil);
      Exit;
    end;
  end;
  tmRefr.Enabled := true;
end;

procedure TfMain.WM_HotKeyHandler(var Message: TMessage);
//==============================================================================
//   hot-keys
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  fuModifiers: word;
  uVirtKey: word;
begin
  fuModifiers:= LOWORD(Message.lParam);
  uVirtKey:= HIWORD(Message.lParam);

  if (fuModifiers = MOD_CONTROL) AND (uVirtKey = VK_F12) then
  begin
    miShowClick(nil);
  end else
  if (fuModifiers = MOD_CONTROL) AND (uVirtKey = VK_F11) then
  begin

    if Fhide then
    begin
      ShowWindow(Self.Handle,SW_SHOWNORMAL); //   
      Fhide := false;
    end;
    TfOrder.ShowOrderForm(ProcessOrder, Top + Fsettings.ConsoleTop, Left+Width-Fsettings.ConsoleRight, Fsettings.ConsoleBlend);
  end;

  inherited;
end;

procedure TfMain.tmRefrTimer(Sender: TObject);
//==============================================================================
//    
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  UpdateForm;
end;

procedure TfMain.RegHotKeys;
//==============================================================================
//  hot-keys
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  Fkeyid: integer;
begin
  Fkeyid := GlobalAddAtom('fxM_Ctrl-F12');
  RegisterHotKey(handle, Fkeyid, MOD_CONTROL, VK_F12);
  FKeyList.Add(pointer(Fkeyid));

  Fkeyid := GlobalAddAtom('fxM_Ctrl-F11');
  RegisterHotKey(handle, Fkeyid, MOD_CONTROL, VK_F11);
  FKeyList.Add(pointer(Fkeyid));
end;

procedure TfMain.UnRegHotKeys;
//==============================================================================
//   hot-keys
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  i: integer;
  Fkeyid: integer;
begin
  for i := 0 to FKeyList.Count - 1 do
  begin
    Fkeyid := integer(FKeyList[i]);

    UnregisterHotKey(handle, Fkeyid);
    GlobalDeleteAtom(Fkeyid);
  end;
  FKeyList.Clear;
end;

procedure TfMain.ProcessOrder(aOrder: string);
//==============================================================================
//   
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  lTicketNo: integer;
  lOrder: string;
  v: integer;
  v1: double;
  v2: double;
  ccy: string;
  lordType: string;
  Fsettings1: TSettingRec;
begin
  lOrder := NormalizeOrder(aOrder);

  if copy(lOrder, 1, 3) = 'SET' then
    FIniFile.WriteString('acc_'+Fsettings.AccountNo, 'set_command', lOrder);


  if copy(lOrder, 1, 1) = 'V' then
  begin
    if trim(lOrder) = 'V*' then
    begin
      Fsettings.accValue := 0;
      Fsettings.accDIR := '';
    end else
    begin
      if not TryStrToFloat(trim(copy(lOrder, 4, length(lOrder))), v1) then
        v1 := 0;

      Fsettings.accValue := 0;
      Fsettings.accDIR := '';

      if length(lOrder)>1 then
        if lOrder[2] = '+' then
        begin
          Fsettings.accDIR := 'BUY';
          Fsettings.accValue := round(StrToFloat(FReader.Values['[DEFCCYBID]']) - v1);
        end else
        if lOrder[2] = '-' then
        begin
          Fsettings.accDIR := 'SELL';
          Fsettings.accValue := round(StrToFloat(FReader.Values['[DEFCCYASK]']) + v1);
        end else
        if (lOrder[2] = 'O')or(lOrder[2] = 'R') then
        begin
          if cbInfo.ItemIndex > -1 then
          begin
            if FReader.OrderLots[cbInfo.ItemIndex] > 0 then
              v2 := FReader.OrderProfit[cbInfo.ItemIndex]/FReader.OrderLots[cbInfo.ItemIndex] else
              v2 := 0;

              lordType := FReader.OrderType[cbInfo.ItemIndex];

              if  (((lordType = 'BUY') or (lordType = 'BUYSTOP') or (lordType = 'BUYLIMIT')) and (lOrder[2] = 'O'))
                  or
                  (((lordType = 'SELL') or (lordType = 'SELLSTOP') or (lordType = 'SELLLIMIT')) and (lOrder[2] = 'R'))
              then
              begin
                Fsettings.accDIR := 'BUY';
                Fsettings.accValue := round(StrToFloat(FReader.Values['[DEFCCYBID]']) - v1 - v2);
              end else
              begin
                Fsettings.accDIR := 'SELL';
                Fsettings.accValue := round(StrToFloat(FReader.Values['[DEFCCYASK]']) + v1 + v2);;
              end;

          end;
        end else
          Fsettings.accValue := 0;
    end;

    FIniFile.WriteFloat('acc_'+Fsettings.AccountNo+'_'+Fsettings.accCCY, 'value', Fsettings.accValue);
    FIniFile.WriteString('acc_'+Fsettings.AccountNo+'_'+Fsettings.accCCY, 'order', Fsettings.accDIR);
    Exit;
  end;

  if (lOrder = 'Q') then
    miExitClick(nil)  else
  if (lOrder = 'S') then
    showSettings else
  if (lOrder = 'M') then
    Close else
  if (lOrder = 'L') then
    ShowMTMessage('', true) else
  begin
    ShowMTMessage(Format('[%s] New command: %s',[DateTimeToStr(now), lOrder]), false);

    lTicketNo := 0;
    if cbInfo.ItemIndex <> -1 then
      lTicketNo := FReader.OrderTicket[cbInfo.ItemIndex];

    if lOrder[1] = 'R' then
    begin
      if cbInfo.ItemIndex <> -1 then
      begin
        if length(lOrder) = 1 then
          v := 1 else
          if not TryStrToInt(trim(copy(lOrder, 2, length(lOrder))), v) then
            v := 0;


        if v > 0 then
        begin
          ccy := FReader.OrderSymbol[cbInfo.ItemIndex];
          Fsettings1 := Fsettings;
          Fsettings1.accLotSize := FReader.OrderLots[cbInfo.ItemIndex];

          if FReader.OrderType[cbInfo.ItemIndex] = 'BUY' then
          begin
            FReader.ExecuteOrder(GetParsedOrder('*', lTicketNo, Fsettings));
            FReader.ExecuteOrder(GetParsedOrder('-'+IntToStr(v), lTicketNo, Fsettings1, ccy));
          end else
          if FReader.OrderType[cbInfo.ItemIndex] = 'SELL' then
          begin
            FReader.ExecuteOrder(GetParsedOrder('*', lTicketNo, Fsettings));
            FReader.ExecuteOrder(GetParsedOrder('+'+IntToStr(v), lTicketNo, Fsettings1, ccy));
          end;
        end;
      end;
    end else
      FReader.ExecuteOrder(GetParsedOrder(lOrder, lTicketNo, Fsettings));
  end;
end;

procedure TfMain.Icon(n: Integer);
//==============================================================================
//  
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  Nim: TNotifyIconData;
  Icon1: TIcon;
begin
	With Nim do
	Begin
  	cbSize := SizeOf(Nim);
  	Wnd := Self.Handle;
	  uID := 1;
	  uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
    Icon1 := TIcon.Create;

    il3.GetIcon(0, Icon1);
	  hicon := Icon1.Handle;
	  uCallbackMessage := wm_user + 1;

    Move(string(Caption+#0)[1],szTip,length(Caption+#0));
	End;

	Case n OF
  	1: Shell_NotifyIcon(Nim_Add,@Nim);
	  2: Shell_NotifyIcon(Nim_Delete,@Nim);
  	3: Shell_NotifyIcon(Nim_Modify,@Nim);
	End;

  Icon1.Free;
end;

procedure TfMain.ControlWindow(var Msg: TMessage);
//==============================================================================
//   hot-keys
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  IF Msg.WParam=SC_MINIMIZE then
  Begin
    HideApp;
  End else
  inherited;
end;

procedure TfMain.IconMouse(var Msg: TMessage);
//==============================================================================
//    
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  p: tpoint;
begin
	GetCursorPos(p);

	case Msg.LParam of
    WM_LBUTTONUP,WM_LBUTTONDBLCLK: miShowClick(nil);
    WM_RBUTTONUP:
    begin
      SetForegroundWindow(Handle);
      pmTray.Popup(p.X,p.Y);
      PostMessage(Handle,WM_NULL,0,0)
    end;
    else
      Icon(3);
  end;
end;

procedure TfMain.miShowClick(Sender: TObject);
//==============================================================================
// / 
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  if not Fhide then
    HideApp  else
  begin
    ShowWindow(Self.Handle,SW_SHOWNORMAL); //   
    Fhide := false;
  end;
end;

procedure TfMain.miExitClick(Sender: TObject);
//==============================================================================
//  
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  Self.OnCloseQuery := nil;
  Close;
end;

procedure TfMain.miMTHideClick(Sender: TObject);
//==============================================================================
//  MT4 
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ShowWindow(FindWindow('MetaQuotes::MetaTrader::4.00',nil), sw_hide);
end;

procedure TfMain.miMTShowClick(Sender: TObject);
//==============================================================================
//  MT4 
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ShowWindow(FindWindow('MetaQuotes::MetaTrader::4.00',nil), sw_show);
end;

procedure TfMain.FormShow(Sender: TObject);
//==============================================================================
//  
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ShowWindow(Application.Handle,SW_HIDE);
  Self.OnShow := nil;

  Icon(1); //    
  AutoSize := True;
end;

procedure TfMain.HideApp;
//==============================================================================
//  
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  if Assigned(Application.OnDeactivate) then
    Application.OnDeactivate(nil);

  ShowWindow(Handle,SW_HIDE); //  
  Fhide := true;
  frmMTMes.Hide;
end;

procedure TfMain.FormKeyPress(Sender: TObject; var Key: Char);
//==============================================================================
//  
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  if (Key = '`') or (Key = '') then
  begin
    if Fhide then
    begin
      ShowWindow(Self.Handle,SW_SHOWNORMAL); //   
      Fhide := false;
    end;

    TfOrder.ShowOrderForm(ProcessOrder, Top + Fsettings.ConsoleTop, Left+Width-Fsettings.ConsoleRight, Fsettings.ConsoleBlend);
    Key := #0;
  end else
  if Key = #27 then
    HideApp;
end;

procedure TfMain.FormClose(Sender: TObject; var Action: TCloseAction);
//==============================================================================
//  MT4   
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================

begin
  miMTShowClick(nil);
end;

procedure TfMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
//==============================================================================
//   ( )
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  CanClose := false;
  HideApp;
end;

function TfMain.CheckOrdersList: boolean;
//==============================================================================
//        .
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  i: integer;
begin
  Result := (cbInfo.Items.Count = FReader.OrderCount);

  if Result and (cbInfo.Items.Count > 0) then
    for i := 0 to FReader.OrderCount - 1 do
      if Result then
        Result := (FReader.OrderTicket[i] = integer(cbInfo.Items.Objects[i]));
end;

procedure TfMain.SaveSettings;
//==============================================================================
//   ini 
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  FIniFile.WriteInteger('form', 'left', Left) ;
  FIniFile.WriteInteger('form', 'top', Top);
  FIniFile.WriteString('form', 'caption', Fsettings.FormCaption);
  FIniFile.WriteString('form', 'order', Fsettings.OrderCaption);
  FIniFile.WriteInteger('form', 'buttons', Fsettings.ShowButtons);

  FIniFile.WriteFloat('form', 'icon', Fsettings.IconBorder);

  FIniFile.WriteInteger('form', 'icon_ColorTPLine', Fsettings.IconColorTPLine);
  FIniFile.WriteInteger('form', 'icon_ColorTPFont', Fsettings.IconColorTPFont);
  FIniFile.WriteInteger('form', 'icon_ColorSLLine', Fsettings.IconColorSLLine);
  FIniFile.WriteInteger('form', 'icon_ColorSLFont', Fsettings.IconColorSLFont);
  FIniFile.WriteInteger('form', 'icon_virtual', Fsettings.IconByVirtual);



  FIniFile.WriteInteger('onsole', 'blend', Fsettings.ConsoleBlend);
  FIniFile.WriteInteger('onsole', 'top', Fsettings.ConsoleTop);
  FIniFile.WriteInteger('onsole', 'right', Fsettings.ConsoleRight);

  FIniFile.WriteInteger('log', 'top', frmMTMes.Top);
  FIniFile.WriteInteger('log', 'Left', frmMTMes.Left);
end;

function TfMain.ParseText(TextIn: string; Index: integer): string;
//==============================================================================
//          
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  FFormatSettings: TFormatSettings;
  v: double;
begin
{
[ACCOUNT] -  
[EQUITY] - 
[BALANCE] - 
[PROFIT] -    =  - 
[ORDERCOUNT] - -   ( )
[TOTALCOUNT] -  -   (     ).   buy  sell ( );
               Buy   +, Sell c -.

[OrderType] -  
[OrderSymbol] -  ( ) 
[OrderTicket] - 
[OrderLots] -    
[OrderProfit] -    
}

  FFormatSettings.DecimalSeparator := '.';
  Result := TextIn;
  Result := StringReplace(Result, '[ACCOUNT]', FReader.Values['[ACCOUNT]'],[rfReplaceAll, rfIgnoreCase]);
  Result := StringReplace(Result, '[EQUITY]', FReader.Values['[EQUITY]'],[rfReplaceAll, rfIgnoreCase]);
  Result := StringReplace(Result, '[BALANCE]', FReader.Values['[BALANCE]'],[rfReplaceAll, rfIgnoreCase]);
  Result := StringReplace(Result, '[PROFIT]', FReader.Values['[PROFIT]'],[rfReplaceAll, rfIgnoreCase]);
  Result := StringReplace(Result, '[SPREAD]', FReader.Values['[SPREAD]'],[rfReplaceAll, rfIgnoreCase]);
  Result := StringReplace(Result, '[ORDERCOUNT]', IntToStr(FReader.OrderCount),[rfReplaceAll, rfIgnoreCase]);
  Result := StringReplace(Result, '[TOTALCOUNT]',
                          Format('%g', [FReader.OrderTotal[FReader.OrderSymbol[cbInfo.ItemIndex]]], FFormatSettings),
                          [rfReplaceAll, rfIgnoreCase]);

  Result := StringReplace(Result, '[OrderType]', FReader.OrderType[Index],[rfReplaceAll, rfIgnoreCase]);
  Result := StringReplace(Result, '[OrderSymbol]', FReader.OrderSymbol[Index],[rfReplaceAll, rfIgnoreCase]);
  Result := StringReplace(Result, '[OrderTicket]', IntToStr(FReader.OrderTicket[Index]),[rfReplaceAll, rfIgnoreCase]);
  Result := StringReplace(Result, '[OrderLots]',
                          Format('%g', [FReader.OrderLots[Index]], FFormatSettings),
                          [rfReplaceAll, rfIgnoreCase]);
  Result := StringReplace(Result, '[OrderProfit]',
                          Format('%g', [FReader.OrderProfit[Index]], FFormatSettings),
                          [rfReplaceAll, rfIgnoreCase]);
  Result := StringReplace(Result, '[OrderIdx]', IntToStr(Index+1),[rfReplaceAll, rfIgnoreCase]);
  if FReader.OrderLots[Index] > 0 then
    v := FReader.OrderProfit[Index]/FReader.OrderLots[Index] else
    v := 0;

  Result := StringReplace(Result, '[OrderProfit2]',
                          Format('%g', [v], FFormatSettings),
                          [rfReplaceAll, rfIgnoreCase]);

  if Assigned(frmMTMes) then
    Result := StringReplace(Result, '[HistoryProfit]',
                            Format('%g', [frmMTMes.FProfit], FFormatSettings),
                            [rfReplaceAll, rfIgnoreCase]);

end;

procedure TfMain.showSettings;
//==============================================================================
//    
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  FFormatSettings: TFormatSettings;
begin
  FFormatSettings.DecimalSeparator := '.';
  fSett := TfmSettings.Create(Application);
  with fSett do
  try
    edCaption.Text := FSettings.FormCaption;
    edOrderCaption.Text := FSettings.OrderCaption;
    seBlend.Value := Fsettings.ConsoleBlend;
    seTop.Value := Fsettings.ConsoleTop;
    seRight.Value := Fsettings.ConsoleRight;
    edIcon.Text := FloatToStr(Fsettings.IconBorder, FFormatSettings);

    cbTPLine.Selected := Fsettings.IconColorTPLine;
    cbTPFont.Selected := Fsettings.IconColorTPFont;
    cbSPLine.Selected := Fsettings.IconColorSLLine;
    cbSLFont.Selected := Fsettings.IconColorSLFont;

    cbVirtual.Checked := (Fsettings.IconByVirtual = 1);

    cbTools.Checked := (Fsettings.ShowButtons = 1);
    fSett.pcMain.ActivePageIndex := 0;
    fSett.UpdateAccountSett(Fsettings);



    if ShowModal = mrOk then
    begin
      FSettings.FormCaption := edCaption.Text;
      FSettings.OrderCaption := edOrderCaption.Text;
      Fsettings.ConsoleBlend := seBlend.Value;
      Fsettings.ConsoleTop := seTop.Value;
      Fsettings.ConsoleRight := seRight.Value;
      if cbTools.Checked then
        Fsettings.ShowButtons := 1 else
        Fsettings.ShowButtons := 0;

      if not TryStrToFloat(StringReplace(edIcon.Text, ',', '.', [rfReplaceAll, rfIgnoreCase]), Fsettings.IconBorder, FFormatSettings) then
        Fsettings.IconBorder := 0;

      Fsettings.IconColorTPLine := cbTPLine.Selected;
      Fsettings.IconColorTPFont := cbTPFont.Selected;
      Fsettings.IconColorSLLine := cbSPLine.Selected;
      Fsettings.IconColorSLFont := cbSLFont.Selected;
      Fsettings.IconByVirtual := ord(cbVirtual.Checked);

      paButtons.Visible := cbTools.Checked;
      fSett.SaveAccountSett(Fsettings);
      SaveAccountSettings;
      SendAccSett2MT;
    end;
  finally
    Free;
    fSett := nil;
  end;
end;

procedure TfMain.sbBuyClick(Sender: TObject);
//==============================================================================
// 
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ProcessOrder('+1');
end;

procedure TfMain.sbSellClick(Sender: TObject);
//==============================================================================
// 
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ProcessOrder('-1');
end;

procedure TfMain.sbCloseClick(Sender: TObject);
//==============================================================================
//   
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ProcessOrder('*');
end;

procedure TfMain.sbReverseClick(Sender: TObject);
//==============================================================================
//  
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ProcessOrder('r');
end;

procedure TfMain.sbSettingsClick(Sender: TObject);
//==============================================================================
//   
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ProcessOrder('s');
end;

procedure TfMain.sbQuitClick(Sender: TObject);
//==============================================================================
//  
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ProcessOrder('q');
end;

procedure TfMain.sbMinimizeClick(Sender: TObject);
//==============================================================================
//  
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ProcessOrder('m');
end;

procedure TfMain.miSettingsClick(Sender: TObject);
//==============================================================================
//   
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ProcessOrder('s');
end;

procedure TfMain.CheckAccount;
//==============================================================================
//    
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  lvAccNo: string;
begin
  lvAccNo := FReader.Values['[ACCOUNT]'];

  if Fsettings.AccountNo <> lvAccNo then
  begin
    Fsettings.accCCY := '';
    Fsettings.accValue := 0;

    if Fsettings.AccountNo <> '' then
    begin
      SaveAccountSettings;
      ShowMTMessage(Format('[%s] Logout: %s',[DateTimeToStr(now), Fsettings.AccountNo]), false);
    end;
    LoadAccountSettings;
    SendAccSett2MT;
    if lvAccNo <> '' then
      ShowMTMessage(Format('[%s] Login: %s',[DateTimeToStr(now), lvAccNo]), false);
  end;

  if Fsettings.accCCY <> FReader.Values['[DEFCCY]'] then
  begin
    Fsettings.accCCY := FReader.Values['[DEFCCY]'];
    Fsettings.accValue := FIniFile.ReadFloat('acc_'+Fsettings.AccountNo+'_'+Fsettings.accCCY, 'value', 0);
    Fsettings.accDIR := FIniFile.ReadString('acc_'+Fsettings.AccountNo+'_'+Fsettings.accCCY, 'order', '');
  end;
end;

procedure TfMain.LoadAccountSettings;
//==============================================================================
//   ini  ,   
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  Fsettings.AccountNo := FReader.Values['[ACCOUNT]'];

  if Fsettings.AccountNo <> '' then
  begin
    Fsettings.accLotSize := FIniFile.ReadFloat('acc_'+Fsettings.AccountNo, 'lot_size', 0.01);
    Fsettings.accTP := FIniFile.ReadInteger('acc_'+Fsettings.AccountNo, 'TP', 0);
    Fsettings.accSL := FIniFile.ReadInteger('acc_'+Fsettings.AccountNo, 'SL', 0);
    Fsettings.accMaxLotSize := FIniFile.ReadInteger('acc_'+Fsettings.AccountNo, 'max_lot_size', 0);
    Fsettings.accMaxLotValue := FIniFile.ReadFloat('acc_'+Fsettings.AccountNo, 'max_lot_value', 0);


    ProcessOrder(FIniFile.ReadString('acc_'+Fsettings.AccountNo, 'set_command', 'SET'));
    FReader.ExecuteOrder(GetParsedOrder('UH', -1, Fsettings));
  end;

  if Assigned(fSett) then
    fSett.UpdateAccountSett(Fsettings);
end;

procedure TfMain.SaveAccountSettings;
//==============================================================================
//     ini 
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  FIniFile.WriteFloat('acc_'+Fsettings.AccountNo, 'lot_size', Fsettings.accLotSize);
  FIniFile.WriteInteger('acc_'+Fsettings.AccountNo, 'TP', Fsettings.accTP);
  FIniFile.WriteInteger('acc_'+Fsettings.AccountNo, 'SL', Fsettings.accSL);
  FIniFile.WriteInteger('acc_'+Fsettings.AccountNo, 'max_lot_size', Fsettings.accMaxLotSize);
  FIniFile.WriteFloat('acc_'+Fsettings.AccountNo, 'max_lot_value', Fsettings.accMaxLotValue);
end;

procedure TfMain.ShowMTMessage(aMessage: string; aShow: boolean);
//==============================================================================
//     
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  frmMTMes.AddMessage(aMessage, aShow);
end;

procedure TfMain.sbLogClick(Sender: TObject);
//==============================================================================
// /  
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ProcessOrder('l');
end;

procedure TfMain.SendAccSett2MT;
//==============================================================================
//   MT4         
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  if Fsettings.AccountNo <> '' then
  begin
    FReader.ExecuteOrder(GetParsedOrder('mls', -1, Fsettings));
    FReader.ExecuteOrder(GetParsedOrder('mlv', -1, Fsettings));
  end;
end;

function TfMain.NormalizeOrder(s: string): string;
//==============================================================================
//     "" 
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
const
  key_Rus: string = '';
  key_Eng: string = 'QWERTYUIOP{}ASDFGHJKL:"ZXCVBNM<>';
var
  s1: string;
  i, k: integer;
begin
  Result := '';
  s1 := AnsiUpperCase(s);
  for i := 1 to length(s1) do
  begin
    k := pos(s1[i], key_Rus);
    if k > 0 then
      Result := Result + key_Eng[k] else
      Result := Result + s1[i];
  end;
end;

function TfMain.RepaintIcon(aValue: double): boolean;
//==============================================================================
//      
//
// :  .                                                12.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  b: Tbitmap;

  lIconLine: integer;
  lIconLine2: integer;
  lIconDigit: integer;
  lIconSign: integer;
  cl_font, cl_line: TColor;
  z: double;
  z1: integer;
begin

  lIconLine := 0;
  lIconLine2 := 0;
  lIconDigit := 0;
  lIconSign := 0;

  if Fsettings.IconBorder > 0 then
  begin //  
    if aValue > 0 then
      lIconSign := 1 else
    if aValue < 0 then
      lIconSign := -1 else
      lIconSign := 0;

    if (lIconSign <> 0) then
    begin
      lIconDigit := Trunc(ABS(aValue)/Fsettings.IconBorder);

      if lIconDigit > 999 then
      begin
        lIconDigit := 999;
        lIconLine2 := 17;
        lIconLine := 0;
      end else
      begin
        z :=  ABS(aValue) - lIconDigit*Fsettings.IconBorder;
        z1 := 1 + ROUND((z/Fsettings.IconBorder)*31);

        if z1 <= 17 then
        begin
         lIconLine2 := z1;
        lIconLine := 0;
        end else
        begin
         lIconLine2 := 16;
         lIconLine := z1-16;
        end;
      end;  
    end;
  end;

  Result := (lIconLine <> FIconLine) or (lIconLine2 <> FIconLine2) or (lIconDigit <> FIconDigit) or (lIconSign <> FIconSign);

  if Result then
  begin //  
    FIconLine := lIconLine;
    FIconLine2 := lIconLine2;
    FIconDigit := lIconDigit;
    FIconSign := lIconSign;


    b := Tbitmap.Create;
    try
      il3.Delete(0);
      if FIconSign = 0 then
        il2.GetBitmap(0, b) else
        il2.GetBitmap(1, b);

      if FIconSign <> 0 then
      begin

        if FIconSign > 0 then
        begin
          cl_font := Fsettings.IconColorTPFont;
          cl_line := Fsettings.IconColorTPLine;
        end else
        begin
          cl_font := Fsettings.IconColorSLFont;
          cl_line := Fsettings.IconColorSLLine;
        end;

        b.Canvas.Pen.Color := cl_line;
        b.Canvas.Brush.Color := cl_line;

        if FIconSign > 0 then
        begin
          b.Canvas.Rectangle(-1,15,FIconLine,16);

          b.Canvas.Rectangle(-1,13,FIconLine2,14);
        end
        else
        begin
          b.Canvas.Rectangle(16-FIconLine,15,17,16);

          b.Canvas.Rectangle(16-FIconLine2,13,17,14);
        end;


        if FIconDigit > 0 then
        begin 
          b.Canvas.Font.Name := 'Tahoma';
          b.Canvas.Font.Color := cl_font;

          b.Canvas.Brush.Color := clNone;
          b.Canvas.Brush.Style := bsClear;
          if FIconDigit < 10 then
          begin
            b.Canvas.Font.Style := [fsBold];     
            b.Canvas.Font.Height := 13;// 24;
            b.Canvas.TextOut(4, 0, IntToStr(FIconDigit));
          end
          else
          if FIconDigit < 100 then
          begin
            b.Canvas.Font.Style := [fsBold];
            b.Canvas.Font.Height := 12;
            b.Canvas.TextOut(2, 0, IntToStr(FIconDigit));
          end
          else
          begin
            b.Canvas.Font.Style := [fsBold];
            b.Canvas.Font.Height := 10;
            b.Canvas.TextOut(1,0,IntToStr(FIconDigit));
          end;
        end;
      end;
      
      il3.AddMasked(b, clblack)
    finally
      b.Free;
    end;
  end;
end;

end.
