unit fmOrder;
//==============================================================================
//   
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TOrderEvent = procedure (aOrder: string) of object;

  TfOrder = class(TForm)
    edOrder: TEdit;
    procedure FormShow(Sender: TObject);
    procedure edOrderExit(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    FOrderEvent: TOrderEvent;
    procedure ProcessCommand;
  public
    class procedure ShowOrderForm(aOrderEvent: TOrderEvent; aTop, aLeft, ablend: integer);
  end;

var
  fOrder: TfOrder;

implementation

{$R *.dfm}

{ TfOrder }

class procedure TfOrder.ShowOrderForm(aOrderEvent: TOrderEvent; aTop, aLeft, ablend: integer);
//==============================================================================
//   
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  if fOrder = nil then
  begin
    fOrder := TfOrder.Create(application);
    fOrder.FOrderEvent := aOrderEvent;
  end;
  fOrder.Top := aTop;
  fOrder.Left := aLeft;
  fOrder.AlphaBlendValue := ablend;

  fOrder.Visible := not fOrder.Visible;
  if fOrder.Visible then
  begin
    Application.Restore;
    Application.BringToFront;
    fOrder.edOrder.SetFocus;
  end;
end;

procedure TfOrder.FormShow(Sender: TObject);
//==============================================================================
//  
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  Application.OnDeactivate := FormDeactivate;
end;

procedure TfOrder.edOrderExit(Sender: TObject);
//==============================================================================
//     
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  Hide;
end;

procedure TfOrder.FormDeactivate(Sender: TObject);
//==============================================================================
//   
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  fOrder.hide;
end;

procedure TfOrder.ProcessCommand;
//==============================================================================
//     
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  if Assigned(FOrderEvent) then FOrderEvent(edOrder.Text);
end;

procedure TfOrder.FormKeyPress(Sender: TObject; var Key: Char);
//==============================================================================
// ` -  
// Enter -     
// Esc -         
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  if (Key = '`') or (Key = '') then
  begin
    hide;
    key := #0;
  end  
  else   
  if ord(Key) = VK_ESCAPE then
  begin
    if edOrder.Text = '' then Hide;
    edOrder.Text := '';
  end else
  if ord(key) = VK_RETURN then
  begin
    Hide;
    if edOrder.Text <> '' then
       ProcessCommand();
    edOrder.Text := '';
  end;
end;

initialization
  fOrder := nil;
end.
