unit fmSetting;
//==============================================================================
//  
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Spin, ComCtrls, ExtCtrls, ColorGrd;

type
  TSettingRec = record
    FormCaption: string;
    OrderCaption: string;
    ConsoleBlend: integer;
    ConsoleTop: integer;
    ConsoleRight: integer;
    ShowButtons: integer;

    IconBorder: double;
    IconColorTPLine: tcolor;
    IconColorTPFont: tcolor;
    IconColorSLLine: tcolor;
    IconColorSLFont: tcolor;
    IconByVirtual: integer;

    AccountNo: string;
    accLotSize: double;
    accTP: integer;
    accSL: integer;
    accMaxLotSize: integer;
    accMaxLotValue: double;

    accCCY: string;
    accValue: double;
    accDIR: string;
  end;

  TfmSettings = class(TForm)
    buok: TBitBtn;
    bucancel: TBitBtn;
    pcMain: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    edCaption: TEdit;
    edOrderCaption: TEdit;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    seBlend: TSpinEdit;
    seTop: TSpinEdit;
    seRight: TSpinEdit;
    tsAbout: TTabSheet;
    tsHelp: TTabSheet;
    meInfo: TMemo;
    gbAccount: TGroupBox;
    Label8: TLabel;
    edLotSize: TEdit;
    Label7: TLabel;
    seTP: TSpinEdit;
    Label6: TLabel;
    seSL: TSpinEdit;
    Label9: TLabel;
    seMaxLCount: TSpinEdit;
    Label10: TLabel;
    edMaxLotValue: TEdit;
    meHelp: TMemo;
    GroupBox2: TGroupBox;
    Label11: TLabel;
    edIcon: TEdit;
    Label12: TLabel;
    cbTPLine: TColorBox;
    Label14: TLabel;
    cbSPLine: TColorBox;
    Label13: TLabel;
    label15: TLabel;
    cbTPFont: TColorBox;
    cbSLFont: TColorBox;
    cbTools: TCheckBox;
    cbVirtual: TCheckBox;
  public
    procedure UpdateAccountSett(s: TSettingRec);
    procedure SaveAccountSett(var s: TSettingRec);
  end;

implementation

{$R *.dfm}

{ TfmSettings }

procedure TfmSettings.SaveAccountSett(var s: TSettingRec);
//==============================================================================
//   
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  FFormatSettings: TFormatSettings;
begin
  FFormatSettings.DecimalSeparator := '.';

  if gbAccount.Enabled then
  begin
    s.accLotSize := StrToFloat(StringReplace(edLotSize.Text, ',', '.', [rfReplaceAll, rfIgnoreCase]), FFormatSettings);
    s.accTP := seTP.Value;
    s.accSL := seSL.Value;
    s.accMaxLotSize := seMaxLCount.Value;
    s.accMaxLotValue := StrToFloat(StringReplace(edMaxLotValue.Text, ',', '.', [rfReplaceAll, rfIgnoreCase]), FFormatSettings);
  end;
end;

procedure TfmSettings.UpdateAccountSett(s: TSettingRec);
//==============================================================================
//    
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  FFormatSettings: TFormatSettings;
begin
  FFormatSettings.DecimalSeparator := '.';
  gbAccount.Enabled := (s.AccountNo <> '');
  if s.AccountNo = '' then
  begin
    gbAccount.Caption := '[-]';
    edLotSize.Text := '';
    seTP.Value := 0;
    seSL.Value := 0;
    seMaxLCount.Value := 0;
    edMaxLotValue.Text := '';
  end else
  begin
    gbAccount.Caption := '['+s.AccountNo+']';
    edLotSize.Text := Format('%g', [s.accLotSize], FFormatSettings);
    seTP.Value := s.accTP;
    seSL.Value := s.accSL;
    seMaxLCount.Value := s.accMaxLotSize;
    edMaxLotValue.Text := Format('%g', [s.accMaxLotValue], FFormatSettings);
  end;
end;

end.
