unit gatemain;
//==============================================================================
//  -      MT4  mt_monitor.
//       
//
// (     : "\\Delphi7\Demos\Internet\NetChat\netchat.dpr" )
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, ShellApi, Menus, Buttons,
  ComCtrls, IniFiles, Sockets, uFxMemoryManager;

type
  TfmGate = class(TForm)
    paMain: TPanel;
    Label1: TLabel;
    edtRemoteHost: TEdit;
    Label2: TLabel;
    edtRemotePort: TEdit;
    Label3: TLabel;
    edtLocalPort: TEdit;
    btnActivateServer: TButton;
    TcpClient1: TTcpClient;
    TcpServer1: TTcpServer;
    pmTray: TPopupMenu;
    miShow: TMenuItem;
    miClose: TMenuItem;
    rgType: TRadioGroup;
    edInterval: TEdit;
    tm: TTimer;
    buHide: TButton;
    buClose: TButton;
    Label4: TLabel;
    buSetInterval: TButton;
    buStop: TButton;
    buStart: TButton;
    laInfo: TLabel;
    procedure TcpServer1Accept(sender: TObject;
      ClientSocket: TCustomIpClient);
    procedure btnActivateServerClick(Sender: TObject);
    procedure miShowClick(Sender: TObject);
    procedure miCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure tmTimer(Sender: TObject);
    procedure buCloseClick(Sender: TObject);
    procedure buHideClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure buSetIntervalClick(Sender: TObject);
    procedure buStartClick(Sender: TObject);
    procedure buStopClick(Sender: TObject);
  private
    FMemFile: TFxMemoryFile;
    FMemDLL: TFxMemoryFile;
    FMemDLL2: TFxMemoryFile;
    FActive: Boolean;
    FpocketSend: integer;
    FpocketSendF: integer;
    FpocketRecive: integer;

    FIniFile: TIniFile;
  protected
    Procedure Icon(n:Integer);
    Procedure IconMouse(var Msg: TMessage); message WM_USER+1;
  private
    procedure SaveSettings;
    procedure LoadSettings;
    procedure UpdateInfoLabel;
    procedure InternalSend(aMemList: TStrings; aHeader: string);
  public
    constructor Create(AOwner: TComponent); override;
    destructor destroy(); override;
  end;

  TClientDataThread = class(TThread)
  public
    ListBuffer: TStringList;
    FMemFile: TFxMemoryFile;
    FReloadFile: boolean;
    la: TLabel;
    FText: string;
    procedure synchAddDataToControl;
    constructor Create(CreateSuspended: Boolean);
    procedure Execute; override;
    procedure Terminate;
  end;

var
  fmGate: TfmGate;

implementation

{$R *.dfm}

constructor TClientDataThread.Create(CreateSuspended: Boolean);
begin
  inherited Create(CreateSuspended);
  FreeOnTerminate := true;
  ListBuffer := TStringList.Create;
end;

procedure TClientDataThread.Terminate;
begin
  ListBuffer.Free;
  inherited;
end;

procedure TClientDataThread.Execute;
begin
  Synchronize(synchAddDataToControl);
end;

procedure TClientDataThread.synchAddDataToControl;
var
  FoldList: TStrings;
  i: integer;
begin
  if FReloadFile then
  begin
    FoldList := TStringList.Create;
    try
      FMemFile.GetList(FoldList);

      if FoldList.Count > 0 then
        for i := FoldList.Count - 1 downto 0 do
          ListBuffer.Insert(0, FoldList[i]);
    finally
      FoldList.Free;
    end;
  end;

  FMemFile.SaveList(ListBuffer);
  la.Caption := FText;
end;

procedure TfmGate.btnActivateServerClick(Sender: TObject);
begin
  TcpServer1.LocalPort := edtLocalPort.Text;
  TcpServer1.Active := True;
end;

procedure TfmGate.Icon(n: Integer);
//==============================================================================
//  
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  Nim: TNotifyIconData;
  s: string;
begin
	With Nim do
	Begin
  	cbSize := SizeOf(Nim);
  	Wnd := Self.Handle;
	  uID := 1;
	  uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
	  hicon := Application.Icon.Handle;
	  uCallbackMessage := wm_user + 1;
    s := Caption + ': '+laInfo.Caption;
    Move(string(s+#0)[1],szTip,length(s+#0));
	End;

	Case n OF
  	1: Shell_NotifyIcon(Nim_Add,@Nim);
	  2: Shell_NotifyIcon(Nim_Delete,@Nim);
  	3: Shell_NotifyIcon(Nim_Modify,@Nim);
	End;

end;

procedure TfmGate.IconMouse(var Msg: TMessage);
//==============================================================================
//    
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  p: tpoint;
begin
	GetCursorPos(p);

	case Msg.LParam of
    WM_LBUTTONUP,WM_LBUTTONDBLCLK: Visible := not Visible;
    WM_RBUTTONUP:
    begin
      SetForegroundWindow(Handle);
      pmTray.Popup(p.X,p.Y);
      PostMessage(Handle,WM_NULL,0,0)
    end;
    else
      Icon(3);
  end;
end;

procedure TfmGate.TcpServer1Accept(sender: TObject;
  ClientSocket: TCustomIpClient);
//==============================================================================
//  
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  s: string;
  DataThread: TClientDataThread;
  sHeader: string;
  sHeader2: string;
begin
  if not FActive then Exit;

  DataThread := TClientDataThread.Create(true);
  DataThread.la := laInfo;

  s := ClientSocket.Receiveln;

  if rgType.ItemIndex = 1 then
  begin
    sHeader := 'hDLL';
    sHeader2 := 'hDLL2';

    if s = sHeader2 then
    begin
      DataThread.FMemFile := FMemDLL2;
      DataThread.FReloadFile := true;
    end else
    begin
      DataThread.FMemFile := FMemDLL;
      DataThread.FReloadFile := false;
    end;
  end else
  begin
    DataThread.FMemFile := FMemFile;
    DataThread.FReloadFile := true;
    sHeader := 'hFile';
    sHeader2 := '';
  end;

  if (s = sHeader)or(s = sHeader2) then
  begin
    s := ClientSocket.Receiveln;
    while s <> '' do
    begin
      DataThread.ListBuffer.Add(s);
      s := ClientSocket.Receiveln;
    end;
    inc(FpocketRecive);
  end;

  DataThread.FText := Format('Send: %d; Send Fail: %d; Receive: %d',
      [FpocketSend, FpocketSendF, FpocketRecive]);
  DataThread.Resume;
end;

procedure TfmGate.miShowClick(Sender: TObject);
//==============================================================================
//  
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  Show;
end;

procedure TfmGate.miCloseClick(Sender: TObject);
//==============================================================================
//  
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  buClose.Click;
end;

destructor TfmGate.destroy;
//==============================================================================
// 
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  tm.OnTimer := nil;
  Icon(2);

  FMemFile.Free;
  FMemDLL.Free;
  FMemDLL2.Free;

  SaveSettings;
  FIniFile.Free;
  inherited;
end;

procedure TfmGate.FormShow(Sender: TObject);
//==============================================================================
//  
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  ShowWindow(Application.Handle,SW_HIDE);
  Icon(1);
end;

constructor TfmGate.Create(AOwner: TComponent);
//==============================================================================
// 
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  inherited;
  FIniFile := TIniFile.Create(Copy(Application.ExeName,1,length(Application.ExeName)-3) + 'ini');

  FMemFile := TFxMemoryFile.Create('MAINFXMONITOR');
  FMemDLL := TFxMemoryFile.Create('DLLFXMONITOR');
  FMemDLL2 := TFxMemoryFile.Create('DLLFXMONITOR2');

  FpocketSend := 0;
  FpocketSendF := 0;
  FpocketRecive := 0;

  FActive := false;
  LoadSettings;
  UpdateInfoLabel;
end;

procedure TfmGate.tmTimer(Sender: TObject);
//==============================================================================
//        
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  FMemList: TStrings;
  sHeader: string;
begin
  tm.Enabled := false;
  if not FActive then Exit;
  try
    FMemList := TStringList.Create;
    try
      if rgType.ItemIndex = 1 then
      begin
        FMemFile.GetList(FMemList);
        sHeader := 'hFile';
      end else
      begin
        FMemDLL2.GetList(FMemList);
        sHeader := 'hDLL2';
      end;

      InternalSend(FMemList, sHeader);
      FMemList.Clear;

      if rgType.ItemIndex = 0 then
      begin
        FMemDLL.GetList(FMemList);
        sHeader := 'hDLL';
        InternalSend(FMemList, sHeader);
      end;

    finally
      FreeAndNil(FMemList);
    end;
  finally
    tm.Enabled := FActive;
  end;
end;

procedure TfmGate.buCloseClick(Sender: TObject);
//==============================================================================
//  
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  OnCloseQuery := nil;

  FActive := False;
  TcpServer1.Active := false;

  Application.ProcessMessages;
  Close;
end;

procedure TfmGate.buHideClick(Sender: TObject);
//==============================================================================
//  
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  Visible := False;
end;

procedure TfmGate.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
//==============================================================================
//   (   )
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  CanClose := False;
  Visible := False;
end;

procedure TfmGate.buSetIntervalClick(Sender: TObject);
//==============================================================================
//    
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  v: integer;
begin
  if TryStrToInt(edInterval.Text, v) then
  begin
    if v < 100 then  v := 100;
    tm.Interval := v;
  end else
    v := 1000;

  edInterval.Text := IntToStr(v);
end;

procedure TfmGate.buStartClick(Sender: TObject);
//==============================================================================
//  ""   
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  btnActivateServer.Click;
  buSetInterval.Click;

  rgType.Enabled := False;
  if rgType.ItemIndex = 0 then
    Caption := 'MetaTrader4 Gate (Active)' else
    Caption := 'mt_monitor Gate (Active)';
  buStart.Enabled := False;
  buStop.Enabled := True;
  FActive := true;
  tm.Enabled := FActive;

  edtRemoteHost.Enabled := False;
  edtRemotePort.Enabled := False;
end;

procedure TfmGate.buStopClick(Sender: TObject);
//==============================================================================
//  ""   
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  FActive := false;
  tm.Enabled := FActive;


  if rgType.ItemIndex = 0 then
    Caption := 'MetaTrader4 Gate (Stoped)' else
    Caption := 'mt_monitor Gate (Stoped)';

  rgType.Enabled := true;

  buStart.Enabled := True;
  buStop.Enabled := False;

  edtRemoteHost.Enabled := True;
  edtRemotePort.Enabled := True;
end;

procedure TfmGate.LoadSettings;
//==============================================================================
//    ini 
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  rgType.ItemIndex := FIniFile.ReadInteger('gate', 'type', 0);

  edtLocalPort.Text := FIniFile.ReadString('gate', 'LocalPort', '5000') ;
  edtRemoteHost.Text := FIniFile.ReadString('gate', 'RemoteHost', 'localhost') ;
  edtRemotePort.Text := FIniFile.ReadString('gate', 'RemotePort', '5000') ;
  edInterval.Text := FIniFile.ReadString('gate', 'Interval', '1000');

  btnActivateServer.Click;
  buSetInterval.Click;
end;

procedure TfmGate.SaveSettings;
//==============================================================================
//    ini 
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  FIniFile.WriteInteger('gate', 'type', rgType.ItemIndex);
  FIniFile.WriteString('gate', 'LocalPort', edtLocalPort.Text);
  FIniFile.WriteString('gate', 'RemoteHost', edtRemoteHost.Text);
  FIniFile.WriteString('gate', 'RemotePort', edtRemotePort.Text);
  FIniFile.WriteString('gate', 'Interval', edInterval.Text);
end;

procedure TfmGate.UpdateInfoLabel;
//==============================================================================
//    /  ( - )
//
// :  .                                                19.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  try
    laInfo.Caption := Format('Send: %d; Send Fail: %d; Receive: %d',
      [FpocketSend, FpocketSendF, FpocketRecive]);
  except
  end;
end;

procedure TfmGate.InternalSend(aMemList: TStrings; aHeader: string);
//==============================================================================
//    
//
// :  .                                                04.04.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  i: integer;
begin
  if aMemList.Count > 0 then
  begin
    TcpClient1.RemoteHost := edtRemoteHost.Text;
    TcpClient1.RemotePort := edtRemotePort.Text;
    try
      if TcpClient1.Connect then
      begin
        TcpClient1.Sendln(aHeader);

        for i := 0 to aMemList.Count - 1 do
          TcpClient1.Sendln(aMemList[i]);
        inc(FpocketSend);
      end else
        inc(FpocketSendF);

      UpdateInfoLabel;
    finally
      TcpClient1.Disconnect;
    end;
  end;
end;

end.
