unit uDLLMain;                                                                    
//==============================================================================
//    mt_dll
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================

interface
uses
  uFxMemoryManager;

procedure Init();
procedure Deinit();
procedure PrepareWrite();
procedure CommitDLL();
procedure WriteDLL(s: string);
function GetOrdersCount(): integer;
function GetOrderInfo(aOrderIndex: integer): string;
procedure WriteDLL2(s: string);

implementation
uses
  Classes, SysUtils;

var
  FMemFile: TFxMemoryFile;
  FMemDLL: TFxMemoryFile;
  FMemDLL2: TFxMemoryFile;
  Flist: TStringList;
  FOrdersList: TStringList;

procedure Init();
//==============================================================================
//  
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  F: TStringList;
begin
  try
    FMemFile := TFxMemoryFile.Create('MAINFXMONITOR');
    FMemDLL := TFxMemoryFile.Create('DLLFXMONITOR');
    FMemDLL2 := TFxMemoryFile.Create('DLLFXMONITOR2');

    F := TStringList.Create;
    try
      FMemFile.GetList(F);
      FMemDLL.GetList(F);
      FMemDLL2.GetList(F);
    finally
      f.Free;
    end;
  except

  end;
end;

procedure Deinit();
//==============================================================================
//  
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  s: TStringList;
begin
  try
    if FMemFile <> nil then
    begin
      s := TStringList.Create;
      try
        FMemFile.GetList(s);
        FMemDLL.GetList(s);
        FMemDLL2.GetList(s);
      finally
        s.Free;
      end;

      FMemFile.Free;
      FMemDLL.Free;
      FMemDLL2.Free;

      FMemFile := nil;
      FMemDLL := nil;
      FMemDLL2 := nil;
    end;
  except
  end;
end;

procedure PrepareWrite();
//==============================================================================
//   4 ()
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  try
    Flist := TStringList.Create;
  except
  end;
end;

procedure WriteDLL(s: string);
//==============================================================================
//   4 ( ,  )
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  try
    if Assigned(Flist) then Flist.Add(s);
  except
  end;
end;

procedure CommitDLL();
//==============================================================================
//   4 ( -   )
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  try
    if Assigned(FMemDLL) and Assigned(Flist) then
      FMemDLL.SaveList(Flist);

    if Assigned(Flist) then
      Flist.Free;

    Flist := nil;
  except
  end;
end;

function GetOrdersCount(): integer;
//==============================================================================
//  -   MT4   mt_monitor
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  Result := 0;
  try
    FOrdersList := TStringList.Create;
    try
      FMemFile.GetList(FOrdersList);
      Result := FOrdersList.Count;
    finally
      if FOrdersList.Count = 0 then
        FreeAndNil(FOrdersList);
    end;
  except
  end;
end;

function GetOrderInfo(aOrderIndex: integer): string;
//==============================================================================
//    
//
// :  .                                                06.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
begin
  try
    if Assigned(FOrdersList) then
      Result := FOrdersList[aOrderIndex] else
      Result := '';

    if FOrdersList.Count = (aOrderIndex+1) then
      FreeAndNil(FOrdersList);
  except
  end;
end;


procedure WriteDLL2(s: string);
//==============================================================================
//   MT4 
//
// :  .                                                04.04.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  Flist2: TStringList;
  i: integer;
begin
  if length(s) > 0 then
  begin
    try
      Flist2 := TStringList.Create;
      try
        FMemDLL2.GetList(FList2);

        if s = 'hclear' then
        begin
          for i := FList2.Count - 1 downto 0 do
            if length(FList2[i]) > 0 then
              if FList2[i][1] = 'h' then
                FList2.Delete(i);
        end;

        Flist2.Add(s);

        if Assigned(FMemDLL2) then
          FMemDLL2.SaveList(Flist2);

      finally
        Flist2.Free;
      end;

    except
    end;
  end;
end;


initialization
  FMemFile := nil;
  FMemDLL := nil;
  FMemDLL2 := nil;
  FOrdersList := nil;
finalization
  Deinit();
end.
