unit uParseOrder;
//==============================================================================
//    
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================

interface
uses
  SysUtils, fmSetting;
function GetParsedOrder(aOrder: string; aTicketNo: integer; s: TSettingRec; aCur: string = ''): string;

implementation
function GetParsedOrder(aOrder: string; aTicketNo: integer; s: TSettingRec; aCur: string = ''): string;
//==============================================================================
//         MT4
// aOrder:  OO LLLLL TTTTTTTTTT SSSSSSSSSSSSSSS PPPPPPPPPPPPPPP CCCCCCCC
//          01 23456 7890123456 789012345678901 234567890123456 78901234
//
//
// O 02[00 .. 01]: BN - buy now; SN - sell now; CN - Close now; BL - Buy Limit; BS - Buy Stop; SL - Sell Limit; SS - Sell Stop; CO - cancel order; MO - Modify Order;
//                 LS - max lots size; LV - max lots value;
// L 05[02 .. 06]: lot size 5,2;
// T 10[07 .. 16]: ticket no
// S 15[17 .. 31]: stop lose 15
// P 15[32 .. 46]: take profit 15
// C 8 [47 .. 54]: currency
//
//
// :  .                                                05.03.2011
// e-mail: albr@ukr.net; icq: 99258304; skype: albr78;
//==============================================================================
var
  v: integer;
  ov: integer;
begin
  result := '';

  if aOrder = 'mls' then
  begin // s.accMaxLotSize
    result := format('%s%-5d%-10s%-15d%-15d',['LS',0,'', s.accMaxLotSize, 0]);
  end else

  if aOrder = 'mlv' then
  begin // s.accMaxLotValue
    ov := round(s.accMaxLotValue * 100);
    result := format('%s%-5d%-10s%-15d%-15d',['LV',0,'', ov, 0]);
  end else

  if aOrder = 'UH' then
  begin //
    result := format('%s%-5d%-10s%-15d%-15d',['UH',0,'', 0, 0]);
  end else

  if copy(aOrder, 1, 3) = 'SET' then
    //   
    result := format('%s%-5s%-10s',['SC','',trim(copy(aOrder, 5, 100))]) else

  if aOrder = '*' then
    //  
    result := format('%s%-5s%-10d',['CO','',aTicketNo]) else
  if TryStrToInt(aOrder, v) then
  begin
    v := abs(v);
    if v > 0 then
    begin
      ov := v * round(s.accLotSize * 100);

      //  
      if aOrder[1] = '+' then
      begin
        result := format('%s%-5d%-10s%-15d%-15d',['BN',ov,'', s.accSL, s.accTP]);
        //'BN000010000000000000000000000000000000000000000';
      end else

      if aOrder[1] = '-' then
      begin
        result := format('%s%-5d%-10s%-15d%-15d',['SN',ov,'', s.accSL, s.accTP]);
        //result := 'SN000010000000000000000000000000000000000000000'
      end;
    end;
  end; 
end;

end.
